//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "Unit1.h"
//---------------------------------------------------------------------------
#include "GO.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

#define CELLSIZE 20

TForm1 *Form1;

// for human move
bool HumanMoved;
int MoveX, MoveY;

typedef enum {HUMAN = 0, COMPUTER = 1} PlayerType;

PlayerType Players[2];
//---------------------------------------------------------------------------

__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------


void __fastcall TForm1::Timer2Timer(TObject *Sender)
{
  Label3->Visible = !Label3->Visible;
}
//---------------------------------------------------------------------------

void TForm1::DrawCross(int X, int Y, TColor Color)
{
  PaintBox1->Canvas->Pen->Color = Color;
  PaintBox1->Canvas->MoveTo(X, Y);
  PaintBox1->Canvas->LineTo(X + CELLSIZE, Y + CELLSIZE);
  PaintBox1->Canvas->MoveTo(X + CELLSIZE, Y);
  PaintBox1->Canvas->LineTo(X, Y + CELLSIZE);
}
//---------------------------------------------------------------------------

void TForm1::DrawNought(int X, int Y, TColor Color)
{
  PaintBox1->Canvas->Pen->Color = Color;
  PaintBox1->Canvas->Ellipse(X, Y, X + CELLSIZE, Y + CELLSIZE);
}
//---------------------------------------------------------------------------

void TForm1::DrawBoard()
{
  PaintBox1->Canvas->Brush->Color = clBlack;

  for (int i = 0; i < N; i++)
    for (int j = 0; j < N; j++)
    {
      int X = i * CELLSIZE, Y = j * CELLSIZE;
      PaintBox1->Canvas->Pen->Color = clGray;
      PaintBox1->Canvas->Rectangle(X, Y, X + CELLSIZE+1, Y + CELLSIZE+1);

      switch (Board[i][j])
      {
        case CROSS:
          DrawCross(X, Y, clLime);
          break;
        case NOUGHT:
          DrawNought(X, Y, clYellow);
          break;
      }
    }

  PaintBox1->Canvas->Pen->Color = clRed;
  
  if (GameWon) // Draw winning line
    for (int l = 0; l < 5; l++)
    {
      int X = (WinningX + WinningDx * l) * CELLSIZE;
      int Y = (WinningY + WinningDy * l) * CELLSIZE;
      if (Player == CROSS)
        DrawCross (X, Y, clRed);
      else
        DrawNought(X, Y, clRed);
    }    
}
//---------------------------------------------------------------------------

void TForm1::HumanMove(int& x, int& y)
{
  Label3->Show();

  HumanMoved = false;

  Timer2->Enabled = true;

  do Application->ProcessMessages(); while (!HumanMoved);

  Timer2->Enabled = false;

  Label3->Hide();

  x = MoveX, y = MoveY;  
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
  Timer1->Enabled = false;

  int x, y;

  if (Players[Player] == HUMAN)
    HumanMove(x, y);
  else
    FindMove(x, y);

  MakeMove(x, y);

  DrawBoard();

  if (GameWon )//|| TotalLines <= 0)
  {
    ShowMessage((Player == CROSS)? "CROSS WON" : "NOUGHT WON");
    Panel1->Show();
    Timer1->Enabled = false;
  }
  else
  {
    Timer1->Enabled = true;
    Player = 1 - Player;
  }  
}
//---------------------------------------------------------------------------

void __fastcall TForm1::PaintBox1MouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
  if (Players[Player] == HUMAN) // human move
  {
    MoveX = X / CELLSIZE;
    MoveY = Y / CELLSIZE;
    HumanMoved = true;
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormPaint(TObject *Sender)
{
  DrawBoard();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
  ResetGame();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::btnPlayClick(TObject *Sender)
{
  Panel1->Hide();
  Players[0] = ComboBox1->ItemIndex;
  Players[1] = ComboBox2->ItemIndex;
  ResetGame();
  Player = CROSS;
  Timer1->Enabled = true;
}
//---------------------------------------------------------------------------

